'=================================================
' Note the PB include files have a mis-defined function
' In WinCrypt.inc, change:
'DECLARE FUNCTION CryptDeriveKey LIB "AdvAPI32.dll" ALIAS "CryptDeriveKey" _
'    (hProv AS DWORD, BYVAL AlgId AS DWORD, BYVAL hBaseData AS DWORD, _
'    BYVAL dwFlags AS DWORD, phKey AS DWORD) AS LONG
'
' to
'
'DECLARE FUNCTION CryptDeriveKey LIB "AdvAPI32.dll" ALIAS "CryptDeriveKey" _
'    (BYVAL hProv AS DWORD, BYVAL AlgId AS DWORD, BYVAL hBaseData AS DWORD, _
'    BYVAL dwFlags AS DWORD, phKey AS DWORD) AS LONG
'     ^^^^^ <- hProv should be BYVAL
'
' You'll need to fix it or work around it to have this work

' WinCred.inc
' Change
'DECLARE FUNCTION CredReadW LIB "AdvApi32.dll" ALIAS "CredReadW" ( _
'    TargetName  AS WSTRINGZ, _
'    BYVAL dType AS DWORD, _
'    BYVAL Flags AS DWORD, _
'    pCred       AS CREDENTIALW) _
'    AS LONG   ' BOOL
'
' to
'
'DECLARE FUNCTION CredReadW LIB "AdvApi32.dll" ALIAS "CredReadW" ( _
'    TargetName  AS WSTRINGZ, _
'    BYVAL dType AS DWORD, _
'    BYVAL Flags AS DWORD, _
'    BYREF pCred AS DWORD) _
'    AS LONG   ' BOOL

'Change
'DECLARE FUNCTION CredReadA LIB "AdvApi32.dll" ALIAS "CredReadA" ( _
'    TargetName  AS ASCIIZ, _
'    BYVAL dType AS DWORD, _
'    BYVAL Flags AS DWORD, _
'    pCred       AS CREDENTIALA) _
'    AS LONG   ' BOOL
'
' to
'
'DECLARE FUNCTION CredReadA LIB "AdvApi32.dll" ALIAS "CredReadA" ( _
'    TargetName  AS ASCIIZ, _
'    BYVAL dType AS DWORD, _
'    BYVAL Flags AS DWORD, _
'    BYREF pCred AS DWORD) _
'    AS LONG   ' BOOL

' Change
'DECLARE FUNCTION CredWriteW LIB "AdvApi32.dll" ALIAS "CredWriteW" ( _
'    BYVAL Cred  AS CREDENTIALW, _
'    BYVAL Flags AS DWORD) _
'    AS LONG  ' BOOL
'
' to
'
'DECLARE FUNCTION CredWriteW LIB "AdvApi32.dll" ALIAS "CredWriteW" ( _
'    BYREF Cred  AS CREDENTIALW, _
'    BYVAL Flags AS DWORD) _
'    AS LONG  ' BOOL
'

'DECLARE FUNCTION CredWriteA LIB "AdvApi32.dll" ALIAS "CredWriteA" ( _
'    BYVAL Cred  AS CREDENTIALA, _
'    BYVAL Flags AS DWORD) _
'    AS LONG  ' BOOL
'
' to
'
'DECLARE FUNCTION CredWriteA LIB "AdvApi32.dll" ALIAS "CredWriteA" ( _
'    BYREF Cred  AS CREDENTIALA, _
'    BYVAL Flags AS DWORD) _
'    AS LONG  ' BOOL
'
' Change
'DECLARE FUNCTION CredDeleteW LIB "AdvApi32.dll" ALIAS "CredDeleteW" ( _
'    TargetName  AS WSTRINGZ, _
'    BYVAL dType AS DWORD, _
'    Flags       AS DWORD) _
'    AS LONG  ' BOOL
'
' to
'
'DECLARE FUNCTION CredDeleteW LIB "AdvApi32.dll" ALIAS "CredDeleteW" ( _
'    TargetName  AS WSTRINGZ, _
'    BYVAL dType AS DWORD, _
'    BYVAL Flags       AS DWORD) _
'    AS LONG  ' BOOL
'
' Change
'DECLARE FUNCTION CredDeleteA LIB "AdvApi32.dll" ALIAS "CredDeleteA" ( _
'    TargetName  AS ASCIIZ, _
'    BYVAL dType AS DWORD, _
'    Flags       AS DWORD) _
'    AS LONG  ' BOOL
'
' to
'
'DECLARE FUNCTION CredDeleteA LIB "AdvApi32.dll" ALIAS "CredDeleteA" ( _
'    TargetName  AS ASCIIZ, _
'    BYVAL dType AS DWORD, _
'    BYVAL Flags       AS DWORD) _
'    AS LONG  ' BOOL


%ENCRYPTION_CONSOLE_OUTPUT = 1
%UsePBDecl = 1
#Include Once "win32api.inc"
#Include Once "wincrypt.inc"
#Include Once "wincred.inc"
#If %Def( %ENCRYPTION_CONSOLE_OUTPUT )
#Include Once "console.inc"
#EndIf

%KEYLENGTH = &h00800000
%ENCRYPT_ALGORITHM = %CALG_RC4
%ENCRYPT_BLOCK_SIZE = 8

Macro PROVIDER = MS_ENHANCED_PROV
Global lastEncryptErrorMessage As String
Global lastEncryptErrorNumber As Long

Sub MyHandleError( psz As String, ByVal nErrorNumber As Long )
	Local buf As StringZ * 1024

	FormatMessage %FORMAT_MESSAGE_FROM_SYSTEM, 0, nErrorNumber, 0, buf, SizeOf( buf ), ByVal 0
	lastEncryptErrorNumber = nErrorNumber
	lastEncryptErrorMessage = buf

#If %Def( %ENCRYPTION_CONSOLE_OUTPUT )
	ConWriteln "An error occurred in the program."
	ConWriteln psz
	ConWriteln Using$( "Error number #: &_.", nErrorNumber, buf )
#EndIf
End Sub

Function EncryptValue( srcValue As String, encValue As String, password As String ) As Long
	Local fReturn As Long
	fReturn = 0
	lastEncryptErrorMessage = ""
	lastEncryptErrorNumber = 0

	Local hCryptProv As Dword
	Local hKey As Dword
	Local hHash As Dword

	Local dwBlockLen As Dword
	Local dwBufferLen As Dword
	Local i, l, ofs, e, fEOF As Long
	Local value As String

#If %Def( %ENCRYPTION_CONSOLE_OUTPUT )
	If ConStdOut=0 Then ConInit()
#EndIf

	If CryptAcquireContext( hCryptProv, ByVal %NULL, PROVIDER, %PROV_RSA_FULL, 0 ) <> 0 Then
#If %Def( %ENCRYPTION_CONSOLE_OUTPUT )
		ConWriteln "A cryptographic provider has been acquired."
#EndIf
	Else
		MyHandleError "Error during CryptAcquireContext!", GetLastError()
		GoTo Exit_MyEncryptFile
	End If

	If CryptCreateHash( hCryptProv, %CALG_MD5, 0, 0, hHash ) <> 0 Then
#If %Def( %ENCRYPTION_CONSOLE_OUTPUT )
		ConWriteln "A hash object has been created."
#EndIf
	Else
		MyHandleError "Error during CryptCreateHash!", GetLastError()
		GoTo Exit_MyEncryptFile
	End If

	If CryptHashData( hHash, ByVal StrPtr( password ), Len( password ), 0 ) <> 0 Then
#If %Def( %ENCRYPTION_CONSOLE_OUTPUT )
		ConWriteln "The password has been added to the hash."
#EndIf
	Else
		MyHandleError "Error during CryptHashData.", GetLastError()
		GoTo Exit_MyEncryptFile
	End If

	If CryptDeriveKey( hCryptProv, %ENCRYPT_ALGORITHM, hHash, %KEYLENGTH, hKey ) <> 0 Then
#If %Def( %ENCRYPTION_CONSOLE_OUTPUT )
		ConWriteln "An encryption key is derived from the password hash."
#EndIf
	Else
		MyHandleError "Error during CryptDeriveKey!", GetLastError()
		GoTo Exit_MyEncryptFile
	End If

	dwBlockLen = 1000 - 1000 Mod %ENCRYPT_BLOCK_SIZE

	If %ENCRYPT_BLOCK_SIZE > 1 Then
		dwBufferLen = dwBlockLen + %ENCRYPT_BLOCK_SIZE
	Else
		dwBufferLen = dwBlockLen
	End If

	e = ((Len(srcValue) + (dwBlockLen-1)) \ dwBlockLen) - 1
	encValue = "" ' Ensure it's intially empty
	For i = 0 To e
		ofs = (i * dwBlockLen) + 1
		value = Mid$( srcValue, ofs, dwBlockLen )
		l = Len( value )
		If Len(value)<dwBufferLen Then
			value = Left$( value + Repeat$( dwBufferLen, $Nul ), dwBufferLen )
		End If
		fEOF = (i = e)

		If CryptEncrypt( hKey, %Null, fEOF, 0, StrPtr(value), l, dwBufferLen ) = 0 Then
			MyHandleError "Error during CryptEncrypt.", GetLastError()
			GoTo Exit_MyEncryptFile
		End If

		encValue += Left$( value, l )
	Next

	fReturn = -1

Exit_MyEncryptFile:
	If hHash <> 0 Then
		If CryptDestroyHash( hHash ) = 0 Then
			MyHandleError "Error during CryptDestroyHash.", GetLastError()
		End If
		hHash = %Null
	End If

	If hKey <> 0 Then
		If CryptDestroyKey( hKey ) = 0 Then
			MyHandleError "Error during CryptDestroyKey!", GetLastError()
		End If
		hKey = 0
	End If

	If hCryptProv <> 0 Then
		If CryptReleaseContext( hCryptProv, 0 ) = 0 Then
			MyHandleError "Error during CryptReleaseContext!", GetLastError()
		End If
	End If

	Function = fReturn
End Function

Function DecryptValue( encValue As String, plainValue As String, password As String ) As Long
	Local fReturn As Long
	fReturn = 0
	lastEncryptErrorMessage = ""
	lastEncryptErrorNumber = 0

	Local hKey As Dword
	Local hHash As Dword
	Local hCryptProv As Dword

	Local dwBlockLen As Dword
	Local dwBufferLen As Dword
	Local fEOF, i, ofs, e, l As Long
	Local value As String

#If %Def( %ENCRYPTION_CONSOLE_OUTPUT )
	If ConStdOut=0 Then ConInit()
#EndIf

	If CryptAcquireContext( hCryptProv, ByVal %Null, PROVIDER, %PROV_RSA_FULL, 0 ) <> 0 Then
#If %Def( %ENCRYPTION_CONSOLE_OUTPUT )
		ConWriteln "A cryptographic provider has been acquired."
#EndIf
	Else
		MyHandleError "Error during CryptAcquireContext!", GetLastError()
		GoTo Exit_MyDecryptFile
	End If

	If CryptCreateHash( hCryptProv, %CALG_MD5, 0, 0, hHash ) = 0 Then
		MyHandleError "Error during CryptCreateHash!", GetLastError()
		GoTo Exit_MyDecryptFile
	End If

	If CryptHashData( hHash, ByVal StrPtr( password ), Len( password ), 0 ) = 0 Then
		MyHandleError "Error during CryptHashData!", GetLastError()
		GoTo Exit_MyDecryptFile
	End If

	If CryptDeriveKey( hCryptProv, %ENCRYPT_ALGORITHM, hHash, %KEYLENGTH, hKey ) = 0 Then
		MyHandleError "Error during CryptDeriveKey!", GetLastError()
		GoTo Exit_MyDecryptFile
	End If

	dwBlockLen = 1000 - ( 1000 Mod %ENCRYPT_BLOCK_SIZE )
	dwBufferLen = dwBlockLen

	plainValue = ""
	e = (( Len( encValue ) + dwBlockLen ) \ dwBlockLen) - 1
	For i = 0 To e
		ofs = (i * dwBlockLen) + 1
		value = Mid$( encValue, ofs, dwBlockLen )
		fEOF = (i=e)
		l = Len(value)
		If l<dwBufferLen Then
			value = Left$( value + Repeat$( dwBufferLen, $Nul ), dwBufferLen )
		End If

		If CryptDecrypt( hKey, 0, fEOF, 0, StrPtr(value), l ) = 0 Then
			MyHandleError "Error during CryptDecrypt!", GetLastError()
			GoTo Exit_MyDecryptFile
		End If

		plainValue += Left$( value, l )
	Next

	fReturn = -1

Exit_MyDecryptFile:
	If hHash <> 0 Then
		If CryptDestroyHash( hHash ) = 0 Then
			MyHandleError "Error during CryptDestroyHash.", GetLastError()
		End If

		hHash = %Null
	End If

	If hKey <> 0 Then
		If CryptDestroyKey( hKey ) = 0 Then
			MyHandleError "Error during CryptDestroyKey!", GetLastError()
		End If
	End If

	If hCryptProv <> 0 Then
		If CryptReleaseContext( hCryptProv, 0 ) = 0 Then
			MyHandleError "Error during CryptReleaseContext!", GetLastError()
		End If
	End If

	Function = fReturn
End Function


Function SaveCredential( credName As String, password As String ) As Long
	Local cred As CREDENTIAL
	Function = -1
#If %Def( %ENCRYPTION_CONSOLE_OUTPUT )
	If ConStdOut=0 Then ConInit()
#EndIf
	lastEncryptErrorMessage = ""
	lastEncryptErrorNumber = 0

	'cred.Flags = %CRED_FLAGS_USERNAME_TARGET
	cred.Type = %CRED_TYPE_GENERIC
	cred.TargetName = StrPtr( credName )
	'cred.Comment
	'cred.LastWritten
	cred.CredentialBlobSize = Len(password)+1
	cred.CredentialBlob = StrPtr(password)
	cred.Persist = %CRED_PERSIST_LOCAL_MACHINE
	'cred.UserName = StrPtr( credName )

	Local result As Long
	result = CredWrite( cred, 0 )
	If result = 0 Then
		MyHandleError "Error writing credential", GetLastError()
		Function = 0
	End If
End Function

Function GetCredential( credName As String ) As String
	Local pcred As CREDENTIAL Ptr
	Local cptr As Dword
	Local pval As StringZ Ptr
	Local result As Long
#If %Def( %ENCRYPTION_CONSOLE_OUTPUT )
	If ConStdOut=0 Then ConInit()
#EndIf
	lastEncryptErrorMessage = ""
	lastEncryptErrorNumber = 0

	result = CredRead( ByVal StrPtr( credName ), %CRED_TYPE_GENERIC, 0, cptr )

	If result = 0 Then
		MyHandleError "Error reading credential", GetLastError()
	Else
		pcred = cptr
		pval = @pcred.CredentialBlob
		Function = Left$( @pval, @pcred.CredentialBlobSize-1 )
	End If

	If pcred<>0 Then CredFree( pcred )
End Function

Function DeleteCredential( credName As String ) As Long
	Local pcred As CREDENTIAL Ptr
	Local cptr As Dword
	Local pval As StringZ Ptr
	Local result As Long
#If %Def( %ENCRYPTION_CONSOLE_OUTPUT )
	If ConStdOut=0 Then ConInit()
#EndIf
	lastEncryptErrorMessage = ""
	lastEncryptErrorNumber = 0

	result = CredDelete( ByVal StrPtr( credName ), %CRED_TYPE_GENERIC, 0 )

	If result = 0 Then
		result = GetLastError()
		If result = %ERROR_NOT_FOUND Then
			' If we didn't find it, it's definitely deleted!
			Function = -1
		Else
			MyHandleError "Error deleting credential", result
			Function = 0
		End If
	Else
		Function = -1
	End If
End Function
